#ifndef _TF5800_
#define _TF5800_


#define is_printable(c) (((c>=0x20) && (c<=0x7f))?1:0)
#define to_printable(c) (((c>=0x20) && (c<=0x7f))?c:' ')
#define to_bcd(h)   (((h/10)<<4) + (h%10))
#define from_bcd(h) (((h>>4)*10) + (h&0xf))

//----------------------------------------------------------------------------
//
//menu stuff
//
#define DESCLEN 0x40
typedef struct {
    int value;
    char string[DESCLEN];
} type_state;

typedef struct {
    int  id;
    char str[0x80];
}type_item;

typedef struct {
    int  id;
    int  visible;
    TYPE_Window win;
    word rgn;
    char *fixme_titlep;
    type_item item[0x20];
}type_menu;

extern dword message_showing;
extern word message_rgn;

extern void ShowMenu(type_menu *menu);
extern void DeleteMenu(type_menu *menu);
//extern void ShowMessage(char* lpMessage, char* lpMessage1, dword dwDelay);
extern dword ShowMessage(char *lpMessage, char *lpMessage1, dword dwDelay, int wait);
extern dword ShowMessage2(char *lpMessage, dword dwDelay, int wait);
dword ShowMessage_xy(char *lpMessage, int x, int y, dword fgcolour, dword bkcolour, dword dwDelay, int wait);
dword ShowMessage_y(char *lpMessage, int y, dword bkcolour, dword dwDelay, int wait);
extern void ShowSvcnumWin(int svc);

//----------------------------------------------------------------------------
extern type_state playmode_str[];
extern type_state rectype_str[];
extern type_state timer_rectype_str[];
extern type_state reserve_type_str[];
extern type_state state_str[];
extern type_state substate_str[];
extern type_state service_type_str[];
extern type_state trickmode_str[];
extern type_state attribute_str[];
extern type_state screen_ratio_str[];
extern type_state display_mode_str[];
extern char *get_str(type_state *str, int index);

//----------------------------------------------------------------------------
//
//log stuff
//
enum {
    DELAY_SHORT  = 100,     //1s
    DELAY_MEDIUM = 500,     //5s
    DELAY_LONG   = 1000,    //10s
};
enum {
    LOG_SERIAL = 1,
    LOG_SCREEN_CONT  = 2,
    LOG_SCREEN_WAIT  = 4,
    LOG_FILE = 8,
};

extern char strLog[0x100];
extern TYPE_File *OpLog;

extern int log_message(int log, char *str, int delay);

//----------------------------------------------------------------------------
//
//log stuff
//
extern char *getdow(int mjd);
extern int getmjd(word mjd, byte *day, byte *month, word *year);
extern char *mjd_to_string(word mjd);
extern int setmjd(int day, int month, int year);

//----------------------------------------------------------------------------
//
//misc stuff
//
extern void dump(void *addr, int length);
extern void dump_reg(type_hook_registers *reg);
extern int dump_channels(void);
extern int get_channel_number(int service_id);
extern void status();

//----------------------------------------------------------------------------
extern char *mjdToString(dword date_time);
extern char *padString(char *in, int len);
//----------------------------------------------------------------------------
//typedef struct
//{
//    dword   tableId                     :8;
//    dword   section_syntax_indicator    :1;
//    dword   reserved                    :3;
//    dword   sectionLength               :12;
//    dword   service_id_h                :8;
//    dword   service_id_l                :8;
//    dword   reserved2                   :2;
//    dword   version_number              :5;
//    dword   current_next_indicator      :1;
//    dword   section_number              :8;
//    dword   lastSectionNumber           :8;
//    dword   transport_stream_id         :16;
//    dword   original_network_id         :16;
//    dword   segment_last_section_number :8;
//    dword   last_table_id               :8;
//    dword   event_id                    :16;
//    dword   start_time_mjd              :16;
//    dword   start_time_hour             :8;
//    dword   start_time_min              :8;
//    dword   start_time_sec              :8;
//    dword   duration                    :24;
//    word    runningStatus               :3;
//    word    free_ca_mode                :1;
//    word    descriptor_loop_length      :12;
//} TYPE_Eit;
//
//----------------------------------------------------------------------------
extern int IsChannelInfoShown(void);
extern int IsAnythingShown(void);
extern int OsdActive(int iStartingRow, int iEndingRow);
//----------------------------------------------------------------------------
extern void ShowMainChannelInfo();
extern void ShowSubChannelInfo();
extern void ShowChannelInfo(int channel_type, int channel_number);
extern void ShowMainChannelEPG();
extern void ShowSubChannelEPG();
extern void ShowChannelEPG(int channel_type, int channel_number);
extern void dumpEvent(TYPE_exTapEvent *evt_info);
extern void dumpFileDetails(TYPE_File *file);
extern void dumpRecording(int slot);
extern void dumpPlaying();
extern void dumpTimer(int timerNo);
//----------------------------------------------------------------------------
extern void benchmark(int state, char *str);
//----------------------------------------------------------------------------
extern void to_bytes(ulong64 value64);
//----------------------------------------------------------------------------

#endif //_TF5800_
